##############################################
#                Please Edit                 #
##############################################

# absolute location to links file (chmod 777)
$links_file = "/home/sites/www.youngvirginpics.com/web/cgi-bin/clickman/links.txt";

# the file name of the error log (chmod 777)
$error_log = "/home/sites/www.youngvirginpics.com/web/cgi-bin/clickman/error_log.txt";

# the asbsolute path of the password file (chmod 777)
$passfile = "/home/sites/www.youngvirginpics.com/web/cgi-bin/clickman/pass.txt";

# the default exit link when all accounts are full
$default_link = "http://www.livecameras.com";

# the url to the click.cgi installed on your server 
$click_cgi_url = "/home/sites/www.youngvirginpics.com/web/cgi-bin/clickman/click.cgi";

# do you want weights adjusted according to in/out traffic?
# 1 - yes - this way the trades that need most get most
# 0 - no - this way you can use the manual controls
# edit calc_weight subroutine if you'd like to alter
# the behaviour of the function.
$auto_weight = 0;

# deliminator used in error log file
# no real need to change, DON'T inclue a '*' as a character
$del = "==";

##############################################
#                 That's it!                 #
##############################################

$version = "2.5b5";


# --- open_links subroutine ---
# fills global link array: @links
# also populates global variables: %name, %url, %clicks, %clicks_left, %weight, %clicks_in
# two additional variables:  	if $input_link is found in the link
#					array, $goto_link gets set to 1

sub open_links {
	my @lines, @elements, $link;
	open (FILE, "+<$links_file") or &error("FILE", $!, "$error_log");
	flock(FILE,2);
	@lines = <FILE>;
	$goto_input = 0;
	foreach $line (@lines) {
		chop ($line) if ($line =~ /\n$/);
		@elements = split(/;/, $line);
		$link = $elements[0];
		if ($link!~/ /) {
			if ($link eq $input_link) {
				$goto_input = 1;
			}
			$name{$link} = $elements[1];
			$url{$link} = $elements[2];
			$clicks{$link} = $elements[3];
			$clicks_left{$link} = $elements[4];
			$weight{$link} = $elements[5];
			$clicks_in{$link} = $elements[6];
			$ratio{$link} = $elements[7];
			$reset_to{$link} = $elements[8];
			push (@links, $link);
		}
	}
}


# --- write_links, close_links subroutines ---
# writes global variables: %name, %url, %clicks, %clicks_left, %weight, %clicks_in
# (close_links simply closes the file without further modification)

sub write_links {
	seek FILE, 0, 0;
	truncate FILE, 0;
	foreach $link (@links) {
		print FILE "$link;$name{$link};$url{$link};$clicks{$link};$clicks_left{$link};";
		print FILE "$weight{$link};$clicks_in{$link};$ratio{$link};$reset_to{$link}\n";
	}
	flock(FILE,8);
	close (FILE);
}

sub close_links {
	flock(FILE,8);
	close (FILE);
}



# --- getLinks subroutine ---
# returns @links
# also populates global variables: %name, %url, %clicks, %clicks_left, %weight

sub getLinks {  
	my @lines;
	my @links;
	my @elements;
	my $link;
	open (FILE, $links_file);
	flock(FILE,2);
	@lines = <FILE>;
	flock(FILE,8);
	close (FILE);
	foreach $line (@lines) {
		chop ($line) if ($line =~ /\n$/);
	}
	foreach $line (@lines) {
		@elements = split(/;/, $line);
		$link = $elements[0];
		$name{$link} = $elements[1];
		$url{$link} = $elements[2];
		$clicks{$link} = $elements[3];
		$clicks_left{$link} = $elements[4];
		$weight{$link} = $elements[5];
		$clicks_in{$link} = $elements[6];
		$ratio{$link} = $elements[7];
		$reset_to{$link} = $elements[8];
		push (@links, $link);
	}
	return (@links);
}


# --- writeLinks subroutine ---
# takes @links list as argument
# uses global variables: %name, %url, %clicks, %clicks_left, %weight
# NOTE: Make sure to use &getLinks to populate first.

sub writeLinks {
	my @links = @_;
	open (FILE, ">" . $links_file) or &error("BANNER", $!, $links_file);	
	flock(FILE,2);
	foreach $link (@links) {
		print FILE "$link;$name{$link};$url{$link};$clicks{$link};$clicks_left{$link};";
		print FILE "$weight{$link};$clicks_in{$link};$ratio{$link};$reset_to{$link}\n";
	}
	flock(FILE,8);
	close (FILE);
}


# --- addLink subroutine ---
# takes $link (account number) as argument
# uses global variables: %name, %url, %clicks, %clicks_left, %weight  for the account

sub addLink {
	my $link = @_[0];
	my @links = &getLinks;
	push (@links, $link);
	$clicks_in{$link} = 0;
	&writeLinks(@links);
}


# --- deleteLink subroutine ---
# takes $link (account number) as argument

sub deleteLink {
	my $link = @_[0];
	my @links = &getLinks;
	my @new_links;
	foreach $element (@links) {
		if ($element ne $link) {
			push (@new_links, $element);
		}
	}
	&writeLinks(@new_links);
}


# --- resetLink subroutine ---
# takes $link (account number) as argument

sub resetLink {
	my $link = $_[0];
	my @links = &getLinks;
	$clicks_left{$link} = $reset_to{$link};
	$clicks{$link} = 0;
	$clicks_in{$link} = 0;
	if ($auto_weight == 1) {
		$weight{$link} = 5;
	}
	&writeLinks(@links);
} 


# --- resetAll subroutine ---
# resets all of the links

sub resetAll {
	my @lines = &getLinks;
	foreach $link (@lines) {
		&resetLink($link);
	}
}


# --- domain subroutine ---
# takes a url as an argument and returns the domain name

sub domain {
	my $url = $_[0];
	my @elements = split(/\//, $url);
	my $domain = @elements[2];
	@elements = split(/\./, $domain);
	$domain = pop(@elements);
	$domain = pop(@elements) . "." . $domain;
	return $domain;
}


# --- calc_weight subroutine ---
# takes the link key as an argument and returns the new weight

sub calc_weight {
	my $link = $_[0];
	my $weight;
	if 	($clicks_left{$link} >= 300) 	{ $weight = 8; }
	elsif ($clicks_left{$link} >= 200)	{ $weight = 6; }
	elsif ($clicks_left{$link} >= 100)	{ $weight = 4; }
	else { $weight = 2; }
	return $weight;
}


# --- myURL subroutine ---
# returns the url of the script running it

sub myURL  {
	my $port = ":" . $ENV{'SERVER_PORT'} if  $ENV{'SERVER_PORT'} != 80;
	return ("http://" . $ENV{'SERVER_NAME'} . $port . $ENV{'SCRIPT_NAME'});
}


# --- error subroutine ---
# writes the file_open error to the error log

sub error {
	local($error, $reason, $file) = @_;
 	if ($error eq "FILE") {
		$now = time;
		open (ERROR, ">>$error_log") or &error("FILE", $!, "$error_log");
		print ERROR "$now$del Cannot access $file$del$reason\n";
		close ERROR;
	}
}


# --- ReadParse subroutine ---
# returns the query string in ($key,$value) array
# returns TRUE if input, FALSE if none

sub ReadParse {
	local (*in) = @_ if @_;
	local ($i, $key, $val);
	if ($ENV{'REQUEST_METHOD'} eq "GET") {
		$in = $ENV{'QUERY_STRING'};
	} elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
		read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
	}
	@in = split(/[&;]/,$in); 
	foreach $i (0 .. $#in) {
		$in[$i] =~ s/\+/ /g;
		($key, $val) = split(/=/,$in[$i],2); 
		$key =~ s/%(..)/pack("c",hex($1))/ge;
		$val =~ s/%(..)/pack("c",hex($1))/ge;
		$in{$key} .= "\0" if (defined($in{$key})); 
		$in{$key} .= $val;
	}
	return scalar(@in); 
}


1;
